/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package freemind.controller;

import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import freemind.view.mindmapview.NodeView;
import freemind.view.mindmapview.MapView;

/**
 * 
 * 
 */
public class NodeMouseListener implements MouseListener {

    private Controller c;

    public NodeMouseListener(MapView view) {
	c = view.getController();
    }

    private void maybeShowPopup( MouseEvent e ) {
	if (e.isPopupTrigger()) {
	    c.showPopupMenu(e.getComponent(),e.getX(),e.getY());
	}
    }

    //
    // Interface MouseListener
    //
    
    public void mouseClicked( MouseEvent e ) {
	if(e.getClickCount() == 2) {
	    c.edit( (NodeView)e.getSource() );
	    e.consume();
	}
    }

    public void mouseEntered( MouseEvent e ) {
    }

    public void mouseExited( MouseEvent e ) {
    }

    public void mousePressed( MouseEvent e ) {
	c.select( (NodeView)e.getSource() );
	maybeShowPopup(e);
	e.consume();
    }
    
    public void mouseReleased( MouseEvent e ) {
	maybeShowPopup(e);
    }

}
    
