/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package freemind.controller;

import freemind.main.Tools;

import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.ButtonGroup;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.KeyStroke;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;

public class PopupMenu extends JPopupMenu {
    private Controller c;

    public PopupMenu(Controller c) {
	this.c = c;
	
	//Node menu
	JMenu nodeMenu = new JMenu("Node");
	this.add(nodeMenu);

	JMenu nodeStyle = new JMenu("Style");
	nodeMenu.add(nodeStyle);

	nodeStyle.add(c.fork);

	nodeStyle.add(c.bubble);

	JMenu nodeFont = new JMenu("Font");
	nodeMenu.add(nodeFont);

	nodeFont.add(c.italic);

	nodeFont.add(c.bold);

	nodeFont.add(c.underlined);

	//If there's a better way to solve this problem, use it!
	ActionListener fontSizeListener = new FontSizeListener();
	JMenu fontSize = new JMenu("Size");
	JMenuItem eight = new JMenuItem("8");
	eight.addActionListener(fontSizeListener);
	fontSize.add(eight);
	JMenuItem ten = new JMenuItem("10");
	ten.addActionListener(fontSizeListener);
	fontSize.add(ten);
	JMenuItem twelve = new JMenuItem("12");
	twelve.addActionListener(fontSizeListener);
	fontSize.add(twelve);
	JMenuItem fourteen = new JMenuItem("14");
	fourteen.addActionListener(fontSizeListener);
	fontSize.add(fourteen);
	JMenuItem sixteen = new JMenuItem("16");
	sixteen.addActionListener(fontSizeListener);
	fontSize.add(sixteen);
	nodeFont.add(fontSize);

	//  ActionListener fontListener = new FontListener();
//  	JMenu fontStyle = new JMenu("Font Style");
//  	nodeFont.add(fontStyle);
//  	for(Enumeration e = Tools.getAllFonts().elements();e.hasMoreElements();) {
//  	    String fontName = (String)e.nextElement();
//  	    JMenuItem item = new JMenuItem(fontName);
//  	    item.addActionListener(fontListener);
//  	    fontStyle.add(item);
//  	}



	nodeMenu.add(c.nodeColor);

	//Edge menu
	JMenu edgeMenu = new JMenu("Edge");
	this.add(edgeMenu);

	JMenu edgeStyle = new JMenu("Style");
	edgeMenu.add(edgeStyle);
	
	edgeStyle.add(c.linear);

	edgeStyle.add(c.bezier);

	edgeMenu.add(c.edgeColor);

    }

    class FontSizeListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    if (e.getActionCommand().equals("8")) {
		c.setFontSize(8);
	    } else if (e.getActionCommand().equals("10")) {
		c.setFontSize(10);
	    } else if (e.getActionCommand().equals("12")) {
		c.setFontSize(12);
	    } else if (e.getActionCommand().equals("14")) {
		c.setFontSize(14);
	    } else if (e.getActionCommand().equals("16")) {
		c.setFontSize(16);
	    } else {
		System.err.println("Tried to set the fontsize to a not available size. This should not happen.");
	    }
	}
    }

   //   class FontListener implements ActionListener {
//  	public void actionPerformed(ActionEvent e) {
//  	    c.setFont(e.getActionCommand());
//  	}
//      }
}

			   
			   
			   
