/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package freemind.controller;

import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import freemind.view.mindmapview.MapView;

/**
 * The KeyListener which belongs to the whole program and
 * cares for Events like C-Q (Quit)
 */
public class TopLevelKeyListener implements KeyListener {

    private Controller c;

    public TopLevelKeyListener( MapView view ) {
	c = view.getController();
    }

    //
    // Interface KeyListener
    //
    
    public void keyTyped( KeyEvent e ) {
    }

    public void keyPressed( KeyEvent e ) {
	if ( e.isControlDown() ) {
	    switch ( e.getKeyCode() ) {
	    case KeyEvent.VK_Q: 
		//c.quit();
		e.consume();
		return;
	    case KeyEvent.VK_ESCAPE:
		c.moveToRoot();
		e.consume();
		return;
	    }
	}
	//	c.getFocus();//steals event the focus from the editor ;-)
    }//keyPressed()

    public void keyReleased( KeyEvent e ) {
    }
}
    












