/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package freemind.view.simpleview;

import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.MutableTreeNode;
import java.lang.NullPointerException;


class MMTreeModelListener implements TreeModelListener {
    
    public void treeNodesChanged( TreeModelEvent e ) {
	MutableTreeNode node;
	node = (MutableTreeNode)(e.getTreePath().getLastPathComponent());
	
	/*
	 * If the event lists children, then the changed
	 * node is the child of the node we've already
	 * gotten.  Otherwise, the changed node and the
	 * specified node are the same.
	 */
	//This seems a bit tricky to me
	try {
	    int index = e.getChildIndices()[0];
	    node = (MutableTreeNode)
		(node.getChildAt(index));
	} catch (NullPointerException exc) {}
    }

    public void treeNodesInserted( TreeModelEvent e ) {
    }

    public void treeNodesRemoved( TreeModelEvent e ) {
    }

    public void treeStructureChanged( TreeModelEvent e) {
    }
}
